import _ from "lodash"
import commonDeclare from "./commonDeclare"
import commonApi from "./commonApi"
export default {
  mixins: [commonApi,commonDeclare],
  data: function () {
    return {
      defFlag:true
    }
  },
  // created: function () {},
  created() {
    if(!this.isInDisplay){
      this.ruleWatcher()
      this.ruleCheck()
    }
  },
  methods: {
    openWatch(flag){
      this.defFlag = !!flag
    },
    ruleWatcher() {
      if(!this.defaultRules)
        return
      const that = this;
      Object.keys(that.defaultRules).forEach(key => {
        let func = function(){
          if(!that.defFlag){
            that.defaultRules[key].apply(that)
          }
        }
        that.$watch("model." + key, _.debounce(func, 1000))
      })
    },
    ruleCheck() {
      if(!this.pattern)
        return
      const keySet = new Set(Object.keys(this.pattern).concat(Object.keys(this.checkRules)))
      const res = {};
      for (let key of keySet.keys()) {
        const rule = []
        if(this.pattern[key]){
          rule.push(...this.pattern[key])
        } 
        if(this.checkRules[key]){
          for (let j = 0; j < this.checkRules[key].length; j++) {
            const check = this.checkRules[key][j];
            rule.push({
              validator: check.bind(this)
            })
          }
        }
        if(rule.length > 0) {
          res[key] = rule;
        }
      }
      this.rules = res;
    },
    changeFormValidateDisabled(flag) {
      const fields = this.$refs.modelForm.fields
      for (let i = 0; i < fields.length; i++) {
          const field = fields[i];
          field.validateDisabled = flag
      }
    }
  },
  computed:{
    isInDisplay(){
      return this.$store.state.Status.mode === 'display'
    }
  }
}